Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.pentaho.di.trans.steps.databaselookup
Class DatabaseLookupMeta

    java.lang.Object
      org.pentaho.di.trans.step.BaseStepMeta
          org.pentaho.di.trans.steps.databaselookup.DatabaseLookupMeta

All Implemented Interfaces:
  Cloneable, StepMetaInterface

    public class DatabaseLookupMeta

extends BaseStepMeta
implements StepMetaInterface

Field Summary
`static int` | `CONDITION_BETWEEN`
`static int` | `CONDITION_EQ`
`static int` | `CONDITION_GE`
`static int` | `CONDITION_GT`
`static int` | `CONDITION_IS_NOT_NULL`
`static int` | `CONDITION_IS_NULL`
`static int` | `CONDITION_LE`
`static int` | `CONDITION_LIKE`
`static int` | `CONDITION_LT`
`static int` | `CONDITION_NE`
`static String[]` | `conditionStrings`

Constructor Summary
`DatabaseLookupMeta()`

Method Summary
`void` | `allocate(int nrkeys, int nrvalues)`
`void` | `analyseImpact(List<DatabaseImpact> impact, TransMeta transMeta, StepMeta stepinfo, org.pentaho.di.core.row.RowMetaInterface prev, String[] input, String[] output, org.pentaho.di.core.row.RowMetaInterface info)` Each step must be able to report on the impact it has on a database, table field, etc.
`void` | `check(List<org.pentaho.di.core.CheckResultInterface> remarks, TransMeta transMeta, StepMeta stepinfo, org.pentaho.di.core.row.RowMetaInterface prev, String[] input, String[] output, org.pentaho.di.core.row.RowMetaInterface info)` Checks the settings of this step and puts the findings in a remarks List.
`Object` | `clone()` Make an exact copy of this step, make sure to explicitly copy Collections etc.
`int` | `getCacheSize()`
`org.pentaho.di.core.database.DatabaseMeta` | `getDatabaseMeta()`
`void` | `getFields(org.pentaho.di.core.row.RowMetaInterface row, String name, org.pentaho.di.core.row.RowMetaInterface[] info, StepMeta nextStep, org.pentaho.di.core.variables.VariableSpace space)` Get the fields that are emitted by this step
`String[]` | `getKeyCondition()`
`String` | `getOrderByClause()`
`String[]` | `getReturnValueDefault()`
`int[]` | `getReturnValueDefaultType()`
`String[]` | `getReturnValueField()`
`String[]` | `getReturnValueNewName()`
`String` | `getSchemaName()`
`StepInterface` | `getStep(StepMeta stepMeta, StepDataInterface stepDataInterface, int cnr, TransMeta transMeta, Trans trans)` Get the executing step, needed by Trans to launch a step.
`StepDataInterface` | `getStepData()` Get a new instance of the appropriate data class.
`String[]` | `getStreamKeyField1()`
`String[]` | `getStreamKeyField2()`
`org.pentaho.di.core.row.RowMetaInterface` | `getTableFields()`
`String[]` | `getTableKeyField()`
`String` | `getTablename()`
`org.pentaho.di.core.database.DatabaseMeta[]` | `getUsedDatabaseConnections()` This method returns all the database connections that are used by the step.
`String` | `getXML()` Produces the XML string that describes this step's information.
`boolean` | `isCached()`
`boolean` | `isEatingRowOnLookupFailure()`
`boolean` | `isFailingOnMultipleResults()`
`boolean` | `isLoadingAllDataInCache()`
`void` | `loadXML(Node stepnode, List<org.pentaho.di.core.database.DatabaseMeta> databases, Map<String,org.pentaho.di.core.Counter> counters)` Load the values for this step from an XML Node
`void` | `readRep(Repository rep, long id_step, List<org.pentaho.di.core.database.DatabaseMeta> databases, Map<String,org.pentaho.di.core.Counter> counters)` Read the steps information from a Kettle repository
`void` | `saveRep(Repository rep, long id_transformation, long id_step)` Save the steps data into a Kettle repository
`void` | `setCached(boolean cached)`
`void` | `setCacheSize(int cacheSize)`
`void` | `setDatabaseMeta(org.pentaho.di.core.database.DatabaseMeta database)`
`void` | `setDefault()` Set default values
`void` | `setEatingRowOnLookupFailure(boolean eatingRowOnLookupFailure)`
`void` | `setFailingOnMultipleResults(boolean failOnMultipleResults)`
`void` | `setKeyCondition(String[] keyCondition)`
`void` | `setLoadingAllDataInCache(boolean loadingAllDataInCache)`
`void` | `setOrderByClause(String orderByClause)`
`void` | `setReturnValueDefault(String[] returnValueDefault)`
`void` | `setReturnValueDefaultType(int[] returnValueDefaultType)`
`void` | `setReturnValueField(String[] returnValueField)`
`void` | `setReturnValueNewName(String[] returnValueNewName)`
`void` | `setSchemaName(String schemaName)`
`void` | `setStreamKeyField1(String[] streamKeyField1)`
`void` | `setStreamKeyField2(String[] streamKeyField2)`
`void` | `setTableKeyField(String[] tableKeyField)`
`void` | `setTablename(String tablename)`
`boolean` | `supportsErrorHandling()`

Methods inherited from class org.pentaho.di.trans.step.BaseStepMeta
`cancelQueries, chosesTargetSteps, excludeFromRowLayoutVerification, exportResources, getDialogClassName, getID, getInfoSteps, getRequiredFields, getRequiredFields, getResourceDependencies, getSQLStatements, getTargetSteps, getUsedArguments, getUsedLibraries, hasChanged, searchInfoAndTargetSteps, setChanged, setChanged, setID, setInfoSteps, setTargetSteps`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.pentaho.di.trans.step.StepMetaInterface
`cancelQueries, excludeFromRowLayoutVerification, exportResources, getDialogClassName, getInfoSteps, getRequiredFields, getRequiredFields, getResourceDependencies, getSQLStatements, getTargetSteps, getUsedArguments, getUsedLibraries, searchInfoAndTargetSteps, setInfoSteps, setTargetSteps`

Field Detail

### conditionStrings

    public static final String[] conditionStrings

### CONDITION_EQ

    public static final int CONDITION_EQ

See Also:
  Constant Field Values

### CONDITION_NE

    public static final int CONDITION_NE

See Also:
  Constant Field Values

### CONDITION_LT

    public static final int CONDITION_LT

See Also:
  Constant Field Values

### CONDITION_LE

    public static final int CONDITION_LE

See Also:
  Constant Field Values

### CONDITION_GT

    public static final int CONDITION_GT

See Also:
  Constant Field Values

### CONDITION_GE

    public static final int CONDITION_GE

See Also:
  Constant Field Values

### CONDITION_LIKE

    public static final int CONDITION_LIKE

See Also:
  Constant Field Values

### CONDITION_BETWEEN

    public static final int CONDITION_BETWEEN

See Also:
  Constant Field Values

### CONDITION_IS_NULL

    public static final int CONDITION_IS_NULL

See Also:
  Constant Field Values

### CONDITION_IS_NOT_NULL

    public static final int CONDITION_IS_NOT_NULL

See Also:
  Constant Field Values

Constructor Detail

### DatabaseLookupMeta

    public DatabaseLookupMeta()

Method Detail

### isCached

    public boolean isCached()

  Returns:
    Returns the cached.

### setCached

    public void setCached(boolean cached)

  Parameters:
    `cached` - The cached to set.

### getCacheSize

    public int getCacheSize()

  Returns:
    Returns the cacheSize.

### setCacheSize

    public void setCacheSize(int cacheSize)

  Parameters:
    `cacheSize` - The cacheSize to set.

### getDatabaseMeta

    public org.pentaho.di.core.database.DatabaseMeta getDatabaseMeta()

  Returns:
    Returns the database.

### setDatabaseMeta

    public void setDatabaseMeta(org.pentaho.di.core.database.DatabaseMeta database)

  Parameters:
    `database` - The database to set.

### getKeyCondition

    public String[] getKeyCondition()

  Returns:
    Returns the keyCondition.

### setKeyCondition

    public void setKeyCondition(String[] keyCondition)

  Parameters:
    `keyCondition` - The keyCondition to set.

### getOrderByClause

    public String getOrderByClause()

  Returns:
    Returns the orderByClause.

### setOrderByClause

    public void setOrderByClause(String orderByClause)

  Parameters:
    `orderByClause` - The orderByClause to set.

### getReturnValueDefault

    public String[] getReturnValueDefault()

  Returns:
    Returns the returnValueDefault.

### setReturnValueDefault

    public void setReturnValueDefault(String[] returnValueDefault)

  Parameters:
    `returnValueDefault` - The returnValueDefault to set.

### getReturnValueDefaultType

    public int[] getReturnValueDefaultType()

  Returns:
    Returns the returnValueDefaultType.

### setReturnValueDefaultType

    public void setReturnValueDefaultType(int[] returnValueDefaultType)

  Parameters:
    `returnValueDefaultType` - The returnValueDefaultType to set.

### getReturnValueField

    public String[] getReturnValueField()

  Returns:
    Returns the returnValueField.

### setReturnValueField

    public void setReturnValueField(String[] returnValueField)

  Parameters:
    `returnValueField` - The returnValueField to set.

### getReturnValueNewName

    public String[] getReturnValueNewName()

  Returns:
    Returns the returnValueNewName.

### setReturnValueNewName

    public void setReturnValueNewName(String[] returnValueNewName)

  Parameters:
    `returnValueNewName` - The returnValueNewName to set.

### getStreamKeyField1

    public String[] getStreamKeyField1()

  Returns:
    Returns the streamKeyField1.

### setStreamKeyField1

    public void setStreamKeyField1(String[] streamKeyField1)

  Parameters:
    `streamKeyField1` - The streamKeyField1 to set.

### getStreamKeyField2

    public String[] getStreamKeyField2()

  Returns:
    Returns the streamKeyField2.

### setStreamKeyField2

    public void setStreamKeyField2(String[] streamKeyField2)

  Parameters:
    `streamKeyField2` - The streamKeyField2 to set.

### getTableKeyField

    public String[] getTableKeyField()

  Returns:
    Returns the tableKeyField.

### setTableKeyField

    public void setTableKeyField(String[] tableKeyField)

  Parameters:
    `tableKeyField` - The tableKeyField to set.

### getTablename

    public String getTablename()

  Returns:
    Returns the tablename.

### setTablename

    public void setTablename(String tablename)

  Parameters:
    `tablename` - The tablename to set.

### isFailingOnMultipleResults

    public boolean isFailingOnMultipleResults()

  Returns:
    Returns the failOnMultipleResults.

### setFailingOnMultipleResults

    public void setFailingOnMultipleResults(boolean failOnMultipleResults)

  Parameters:
    `failOnMultipleResults` - The failOnMultipleResults to set.

### loadXML

    public void loadXML(Node stepnode,
                        List<org.pentaho.di.core.database.DatabaseMeta> databases,
                        Map<String,org.pentaho.di.core.Counter> counters)
                 throws org.pentaho.di.core.exception.KettleXMLException

  Description copied from interface: `StepMetaInterface`
  Load the values for this step from an XML Node

  Specified by:
    `loadXML` in interface `StepMetaInterface`
  Parameters:
    `stepnode` - the Node to get the info from
    `databases` - The available list of databases to reference to
    `counters` - Counters to reference.
  Throws:
    `org.pentaho.di.core.exception.KettleXMLException` - When an unexpected XML error occurred. (malformed etc.)

### allocate

    public void allocate(int nrkeys,
                         int nrvalues)

### clone

    public Object clone()

  Description copied from interface: `StepMetaInterface`
  Make an exact copy of this step, make sure to explicitly copy Collections etc.

  Specified by:
    `clone` in interface `StepMetaInterface`
  Overrides:
    `clone` in class `BaseStepMeta`
  Returns:
    an exact copy of this step

### setDefault

    public void setDefault()

  Description copied from interface: `StepMetaInterface`
  Set default values

  Specified by:
    `setDefault` in interface `StepMetaInterface`

### getFields

    public void getFields(org.pentaho.di.core.row.RowMetaInterface row,
                          String name,
                          org.pentaho.di.core.row.RowMetaInterface[] info,
                          StepMeta nextStep,
                          org.pentaho.di.core.variables.VariableSpace space)
                   throws org.pentaho.di.core.exception.KettleStepException

  Description copied from interface: `StepMetaInterface`
  Get the fields that are emitted by this step

  Specified by:
    `getFields` in interface `StepMetaInterface`
  Overrides:
    `getFields` in class `BaseStepMeta`
  Parameters:
    `row` - The fields that are entering the step. These are changed to reflect the output metadata.
    `name` - The name of the step to be used as origin
    `info` - The input rows metadata that enters the step through the specified channels in the same order as in method getInfoSteps(). The step metadata can then choose what to do with it: ignore it or not. Interesting is also that in case of database lookups, the layout of the target database table is put in info[0]
    `nextStep` - if this is a non-null value, it's the next step in the transformation. The one who's asking, the step where the data is targetted towards.
    `space` - TODO
  Throws:
    `org.pentaho.di.core.exception.KettleStepException` - when an error occurred searching for the fields.

### getXML

    public String getXML()

  Description copied from class: `BaseStepMeta`
  Produces the XML string that describes this step's information.

  Specified by:
    `getXML` in interface `StepMetaInterface`
  Overrides:
    `getXML` in class `BaseStepMeta`
  Returns:
    String containing the XML describing this step.

### readRep

    public void readRep(Repository rep,
                        long id_step,
                        List<org.pentaho.di.core.database.DatabaseMeta> databases,
                        Map<String,org.pentaho.di.core.Counter> counters)
                 throws org.pentaho.di.core.exception.KettleException

  Description copied from interface: `StepMetaInterface`
  Read the steps information from a Kettle repository

  Specified by:
    `readRep` in interface `StepMetaInterface`
  Parameters:
    `rep` - The repository to read from
    `id_step` - The step ID
    `databases` - The databases to reference
    `counters` - The counters to reference
  Throws:
    `org.pentaho.di.core.exception.KettleException` - When an unexpected error occurred (database, network, etc)

### saveRep

    public void saveRep(Repository rep,
                        long id_transformation,
                        long id_step)
                 throws org.pentaho.di.core.exception.KettleException

  Description copied from interface: `StepMetaInterface`
  Save the steps data into a Kettle repository

  Specified by:
    `saveRep` in interface `StepMetaInterface`
  Parameters:
    `rep` - The Kettle repository to save to
    `id_transformation` - The transformation ID
    `id_step` - The step ID
  Throws:
    `org.pentaho.di.core.exception.KettleException` - When an unexpected error occurred (database, network, etc)

### check

    public void check(List<org.pentaho.di.core.CheckResultInterface> remarks,
                      TransMeta transMeta,
                      StepMeta stepinfo,
                      org.pentaho.di.core.row.RowMetaInterface prev,
                      String[] input,
                      String[] output,
                      org.pentaho.di.core.row.RowMetaInterface info)

  Description copied from interface: `StepMetaInterface`
  Checks the settings of this step and puts the findings in a remarks List.

  Specified by:
    `check` in interface `StepMetaInterface`
  Parameters:
    `remarks` - The list to put the remarks in @see org.pentaho.di.core.CheckResult
    `stepinfo` - The stepMeta to help checking
    `prev` - The fields coming from the previous step
    `input` - The input step names
    `output` - The output step names
    `info` - The fields that are used as information by the step

### getTableFields

    public org.pentaho.di.core.row.RowMetaInterface getTableFields()

  Specified by:
    `getTableFields` in interface `StepMetaInterface`
  Overrides:
    `getTableFields` in class `BaseStepMeta`
  Returns:
    The fields used by this step, this is being used for the Impact analyses.

### getStep

    public StepInterface getStep(StepMeta stepMeta,
                                 StepDataInterface stepDataInterface,
                                 int cnr,
                                 TransMeta transMeta,
                                 Trans trans)

  Description copied from interface: `StepMetaInterface`
  Get the executing step, needed by Trans to launch a step.

  Specified by:
    `getStep` in interface `StepMetaInterface`
  Parameters:
    `stepMeta` - The step info
    `stepDataInterface` - the step data interface linked to this step. Here the step can store temporary data, database connections, etc.
    `cnr` - The copy nr to get
    `transMeta` - The transformation info
    `trans` - The launching transformation

### getStepData

    public StepDataInterface getStepData()

  Description copied from interface: `StepMetaInterface`
  Get a new instance of the appropriate data class. This data class implements the StepDataInterface. It basically contains the persisting data that needs to live on, even if a worker thread is terminated.

  Specified by:
    `getStepData` in interface `StepMetaInterface`
  Returns:
    The appropriate StepDataInterface class.

### analyseImpact

    public void analyseImpact(List<DatabaseImpact> impact,
                              TransMeta transMeta,
                              StepMeta stepinfo,
                              org.pentaho.di.core.row.RowMetaInterface prev,
                              String[] input,
                              String[] output,
                              org.pentaho.di.core.row.RowMetaInterface info)

  Description copied from class: `BaseStepMeta`
  Each step must be able to report on the impact it has on a database, table field, etc.

  Specified by:
    `analyseImpact` in interface `StepMetaInterface`
  Overrides:
    `analyseImpact` in class `BaseStepMeta`
  Parameters:
    `impact` - The list of impacts @see org.pentaho.di.transMeta.DatabaseImpact
    `transMeta` - The transformation information
    `stepinfo` - The step information
    `prev` - The fields entering this step
    `input` - The previous step names
    `output` - The output step names
    `info` - The fields used as information by this step

### getUsedDatabaseConnections

    public org.pentaho.di.core.database.DatabaseMeta[] getUsedDatabaseConnections()

  Description copied from class: `BaseStepMeta`
  This method returns all the database connections that are used by the step.

  Specified by:
    `getUsedDatabaseConnections` in interface `StepMetaInterface`
  Overrides:
    `getUsedDatabaseConnections` in class `BaseStepMeta`
  Returns:
    an array of database connections meta-data. Return an empty array if no connections are used.

### isEatingRowOnLookupFailure

    public boolean isEatingRowOnLookupFailure()

  Returns:
    Returns the eatingRowOnLookupFailure.

### setEatingRowOnLookupFailure

    public void setEatingRowOnLookupFailure(boolean eatingRowOnLookupFailure)

  Parameters:
    `eatingRowOnLookupFailure` - The eatingRowOnLookupFailure to set.

### getSchemaName

    public String getSchemaName()

  Returns:
    the schemaName

### setSchemaName

    public void setSchemaName(String schemaName)

  Parameters:
    `schemaName` - the schemaName to set

### supportsErrorHandling

    public boolean supportsErrorHandling()

  Specified by:
    `supportsErrorHandling` in interface `StepMetaInterface`
  Overrides:
    `supportsErrorHandling` in class `BaseStepMeta`
  Returns:
    true if this step supports error "reporting" on rows: the ability to send rows to a certain target step.

### isLoadingAllDataInCache

    public boolean isLoadingAllDataInCache()

  Returns:
    the loadingAllDataInCache

### setLoadingAllDataInCache

    public void setLoadingAllDataInCache(boolean loadingAllDataInCache)

  Parameters:
    `loadingAllDataInCache` - the loadingAllDataInCache to set

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD